# 経理システム (仮) -- 
# Copyright (C) 2007 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/


class ApplicationController < ActionController::Base
  # Acts as Authenticatedプラグインを使用する。
  include AuthenticatedSystem

end

#################################################################
# 共通ルーチン


# 3桁ごとにカンマを挿入
def format_amount(n, exp)
  n = Float(n) / (10.0 ** exp) if exp != 0
  intpart, exppart = n.to_s.split('.', 2)
  intstr = intpart.reverse.split(/([0-9]{1,3})/).collect {|d| d == "" ? ',' : d}.join('').reverse.chop
  if exp != 0
    sprintf("%s.%s%s", intstr, exppart, "0" * (exp - exppart.length))
  else
    sprintf("%s", intstr)
  end
end

def edit_amount(n, exp)
  if n
    if exp != 0
      (Float(n) / (10.0 ** exp)).to_s
    else
      n.to_s
    end
  else
    ""
  end
end


def date_select2 obj, method
  r = date_select obj, method
  r << %Q!<input type="button" onClick="openCalendar(this.form.#{obj}_#{method}_1i, this.form.#{obj}_#{method}_2i, this.form.#{obj}_#{method}_3i, event, &#39;yy/mm/dd&#39;);" value="..." style="padding:0">!
  return r
end

def date_from_select(s, name)
  return Date.new(s["#{name}(1i)"].to_i, s["#{name}(2i)"].to_i, s["#{name}(3i)"].to_i)
end

################ 文字コード関係

# UTF-8 to Shift_JIS (cp932)
def utf2sjis s
  if s
    NKF.nkf('-m0 -s -W', s)
  else
    nil
  end
end

def sjis2utf s
  if s
    NKF.nkf('-w -S -m0', s)
  else
    nil
  end
end

# Unicodeの正規化
def norm(s)
  s ? ActiveSupport::Multibyte::Handlers::UTF8Handler.normalize(s, :kc) : nil
end
