# -*- encoding:utf-8 -*-

# 経理システム (仮)
# Copyright (C) 2007 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/


require 'partner_search_box'

# 取引先に紐づける（振込先）銀行口座
class BankAccountsController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    #@bank_account_pages, @bank_accounts = paginate :bank_accounts, :per_page => 10
    @bank_accounts = BankAccount.paginate :page => params[:page], :per_page => 20
  end

  def show
    @bank_account = BankAccount.find(params[:id])
  end

  def new
    @bank_account = BankAccount.new
  end

  def create
    @bank_account = BankAccount.new(params[:bank_account])
    if @bank_account.save
      flash[:notice] = 'BankAccount was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @bank_account = BankAccount.find(params[:id])
  end

  def update
    @bank_account = BankAccount.find(params[:id])
    if @bank_account.update_attributes(params[:bank_account])
      flash[:notice] = 'BankAccount was successfully updated.'
      redirect_to :action => 'show', :id => @bank_account
    else
      render :action => 'edit'
    end
  end

  def destroy
    BankAccount.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
  
  # 紐づける取引先を変更する画面
  def change_partner
    @bank_account = BankAccount.find params[:id]
  end
  
  def change_partner2
    @bank_account = BankAccount.find params[:id]

    @search = PartnerSearchBox.new(params[:search])
    @partners = @search.find_by_text
  end
  
  def change_partner_do
    @bank_account = BankAccount.find params[:id]
    @partner = Partner.find params[:partner]

    @bank_account.partner = @partner
    if @bank_account.save
      flash[:notice] = '銀行口座は正常に更新されました。'
      redirect_to :controller => 'partners', :action => 'show', :id => @partner
    else
      raise
    end
  end

end
