# -*- encoding:utf-8 -*-

# 経理システム (仮)
# Copyright (C) 2007 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/


# 売上側の請求書 (売掛金管理)
class SalesInvoicesController < ApplicationController
  append_after_filter :make_pdf, :only => :print_invoice
  
  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def index
    list
    render :action => 'list'
  end
  
  SCRIPT_DIR = File.dirname(__FILE__) + '/../../script'
  # PDFに変換する
  def make_pdf
    File.open('/tmp/q', 'w') {|f| f.write response.body }
    headers['Content-Type'] = 'application/pdf'
    ENV['JAVA_HOME'] = '/usr/java/latest'
    `/opt/fop-0.94/fop -c #{SCRIPT_DIR}/fop-conf.xml /tmp/q -pdf /tmp/r`
    response.body = File.read('/tmp/r')
  end
  private :make_pdf
  
  # 作った請求書を出力
  def print_invoice
    require 'ostruct'  # DEBUG

    @company = OpenStruct.new(
              :name => '株式会社 テスト商事',
              :url => 'www.yahoo!!!.com',
              :address => '福岡市博多区2丁目2-1 FooBarビル',
              :tel => '092-555-1111',
              :zip => '812-xxxx',
              :finance_dept => '財務経理部長　田中　太郎',
              :person => 'ほげ山ほげ太',
        :banks => [
          OpenStruct.new(:bank_name => '三井住友銀行',
                       :branch_name => '天神支店',
                       :kubun => '普通',
                      :account => '1239876')
        ]    )
    @invoice = OpenStruct.new(
      :partner => OpenStruct.new(
        :name => 'ほげほげ商事 株式会社',
        :address => '東京都港区赤坂・・・・・　ほげんたビル200F',
        :zip => '112-9999'
      ),
      :si_details => [
           OpenStruct.new(:desc => 'カーペット　緑色の',
                    :unit_price => '1234567.0000',
                    :qty => '123',
                    :unit => 'm'),
           OpenStruct.new(:desc => 'カーペット　緑色の',
                    :unit_price => '1234567.0000',
                    :qty => '123',
                    :unit => 'm')
          ],
      :due_day => Date.new(2008,1,31)
    )
    @today = Date.today
    render :layout => false
  end
  
  def list
    #@sales_invoice_pages, @sales_invoices = paginate :sales_invoices, :per_page => 10
    @sales_invoices = SalesInvoice.paginate :page => params[:page], :per_page => 20
  end

  def show
    @sales_invoice = SalesInvoice.find(params[:id])
  end

  def new
    @sales_invoice = SalesInvoice.new
  end

  def create
    @sales_invoice = SalesInvoice.new(params[:sales_invoice])
    if @sales_invoice.save
      flash[:notice] = 'SalesInvoice was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @sales_invoice = SalesInvoice.find(params[:id])
  end

  def update
    @sales_invoice = SalesInvoice.find(params[:id])
    if @sales_invoice.update_attributes(params[:sales_invoice])
      flash[:notice] = 'SalesInvoice was successfully updated.'
      redirect_to :action => 'show', :id => @sales_invoice
    else
      render :action => 'edit'
    end
  end

  def destroy
    SalesInvoice.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
