# 部門
class Division < ActiveRecord::Base
  has_many :controllers_divisions
  has_many :control_divisions, :through => :controllers_divisions
  belongs_to :role

  @@addable_cache = nil
  def self.addable()
    if !@@addable_cache
      all = find :all, :conditions => '(end_day IS NULL) AND purchase_active <> 0', :order => 'division_code'
      @@addable_cache = all.select {|r|
        !['0'].include?(r.division_code)
      }
    end
    return @@addable_cache
  end
  
  def name2
    return "#{division_code} #{name}"
  end

  # 「所属」の視点でのコストセンタ
  def default_controller
    # TODO: まじめに作ること
    c = control_divisions.first
    raise if !c
    return c
  end
  
  # 
  def controller(root_controller)
    raise if !root_controller
    ControlDivision.find :first,
                 :select => 'control_divisions.*',
                 :joins => 'JOIN controllers_divisions ON
                     control_divisions.id = controllers_divisions.control_division_id',
                 :conditions => ['division_id = ? AND parent_id = ?',
                                 attributes['id'], root_controller.id]
  end
end
